You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

960 lines
26 KiB

9 years ago
9 years ago
9 years ago
9 years ago
9 years ago
9 years ago
9 years ago
9 years ago
9 years ago
9 years ago
9 years ago
9 years ago
9 years ago
  1. #!/bin/bash
  2. ## Bash wrap script to launch the ``compose`` docker with right options.
  3. ##
  4. ##
  5. ## Launcher
  6. ## - should need minimum requirement to run
  7. ## - no shell libs
  8. ##
  9. [[ "${BASH_SOURCE[0]}" != "${0}" ]] && SOURCED=true
  10. ##
  11. ## From kal-shlib
  12. ##
  13. ANSI_ESC=$'\e['
  14. md5_compat() {
  15. if get_path md5sum >/dev/null; then
  16. md5_compat() { md5sum | cut -c -32; }
  17. elif get_path md5 >/dev/null; then
  18. md5_compat() { md5; }
  19. else
  20. die "$exname: required GNU or BSD date not found"
  21. fi
  22. md5_compat
  23. }
  24. ## output on stdout the next record on stdin separated by a '\0'
  25. next-0() {
  26. local ans IFS=''
  27. read -r -d '' ans &&
  28. echo -n "$ans"
  29. }
  30. array_read-0() {
  31. local elt aname
  32. while true; do
  33. for aname in "$@"; do
  34. declare -n cur="$aname"
  35. elt="$(next-0)" || return 0
  36. cur+=("$elt")
  37. done
  38. done
  39. }
  40. str_pattern_matches() {
  41. local str="$1"
  42. shift
  43. for pattern in "$@"; do
  44. eval "[[ \"$str\" == $pattern ]]" && return 0
  45. done
  46. return 1
  47. }
  48. ansi_color() {
  49. local choice="$1"
  50. if [ "$choice" == "tty" ]; then
  51. if [ -t 1 ]; then
  52. choice="yes"
  53. else
  54. choice="no"
  55. fi
  56. fi
  57. if [ "$choice" != "no" ]; then
  58. SET_COL_CHAR="${ANSI_ESC}${COL_CHAR}G"
  59. SET_COL_STATUS="${ANSI_ESC}${COL_STATUS}G"
  60. SET_COL_INFO="${ANSI_ESC}${COL_INFO}G"
  61. SET_COL_ELT="${ANSI_ESC}${COL_ELT}G"
  62. SET_BEGINCOL="${ANSI_ESC}0G"
  63. UP="${ANSI_ESC}1A"
  64. DOWN="${ANSI_ESC}1B"
  65. LEFT="${ANSI_ESC}1D"
  66. RIGHT="${ANSI_ESC}1C"
  67. SAVE="${ANSI_ESC}7"
  68. RESTORE="${ANSI_ESC}8"
  69. NORMAL="${ANSI_ESC}0m"
  70. GRAY="${ANSI_ESC}1;30m"
  71. RED="${ANSI_ESC}1;31m"
  72. GREEN="${ANSI_ESC}1;32m"
  73. YELLOW="${ANSI_ESC}1;33m"
  74. BLUE="${ANSI_ESC}1;34m"
  75. PINK="${ANSI_ESC}1;35m"
  76. CYAN="${ANSI_ESC}1;36m"
  77. WHITE="${ANSI_ESC}1;37m"
  78. DARKGRAY="${ANSI_ESC}0;30m"
  79. DARKRED="${ANSI_ESC}0;31m"
  80. DARKGREEN="${ANSI_ESC}0;32m"
  81. DARKYELLOW="${ANSI_ESC}0;33m"
  82. DARKBLUE="${ANSI_ESC}0;34m"
  83. DARKPINK="${ANSI_ESC}0;35m"
  84. DARKCYAN="${ANSI_ESC}0;36m"
  85. DARKWHITE="${ANSI_ESC}0;37m"
  86. SUCCESS=$GREEN
  87. WARNING=$YELLOW
  88. FAILURE=$RED
  89. NOOP=$BLUE
  90. ON=$SUCCESS
  91. OFF=$FAILURE
  92. ERROR=$FAILURE
  93. else
  94. SET_COL_CHAR=
  95. SET_COL_STATUS=
  96. SET_COL_INFO=
  97. SET_COL_ELT=
  98. SET_BEGINCOL=
  99. NORMAL=
  100. RED=
  101. GREEN=
  102. YELLOW=
  103. BLUE=
  104. GRAY=
  105. WHITE=
  106. DARKGRAY=
  107. DARKRED=
  108. DARKGREEN=
  109. DARKYELLOW=
  110. DARKBLUE=
  111. DARKPINK=
  112. DARKCYAN=
  113. SUCCESS=
  114. WARNING=
  115. FAILURE=
  116. NOOP=
  117. ON=
  118. OFF=
  119. ERROR=
  120. fi
  121. ansi_color="$choice"
  122. export SET_COL_CHAR SET_COL_STATUS SET_COL_INFO SET_COL_ELT \
  123. SET_BEGINCOL UP DOWN LEFT RIGHT SAVE RESTORE NORMAL \
  124. GRAY RED GREEN YELLOW BLUE PINK CYAN WHITE DARKGRAY \
  125. DARKRED DARKGREEN DARKYELLOW DARKBLUE DARKPINK DARKCYAN \
  126. SUCCESS WARNING FAILURE NOOP ON OFF ERROR ansi_color
  127. }
  128. e() { printf "%s" "$*"; }
  129. warn() { e "${YELLOW}Warning:$NORMAL" "$*"$'\n' >&2 ; }
  130. info() { e "${BLUE}II$NORMAL" "$*"$'\n' >&2 ; }
  131. verb() { [ -z "$VERBOSE" ] || e "$*"$'\n' >&2; }
  132. debug() { [ -z "$DEBUG" ] || e "$*"$'\n' >&2; }
  133. err() { e "${RED}Error:$NORMAL $*"$'\n' >&2 ; }
  134. die() { err "$@" ; exit 1; }
  135. ## equivalent of 'xargs echo' with builtins
  136. nspc() {
  137. local content
  138. content=$(printf "%s " $(cat -))
  139. printf "%s" "${content::-1}"
  140. }
  141. get_path() { (
  142. IFS=:
  143. for d in $PATH; do
  144. filename="$d/$1"
  145. [ -f "$filename" -a -x "$filename" ] && {
  146. echo "$d/$1"
  147. return 0
  148. }
  149. done
  150. return 1
  151. ) }
  152. depends() {
  153. ## Avoid colliding with variables that are created with depends.
  154. local __i __path __new_name
  155. for __i in "$@"; do
  156. if ! __path=$(get_path "$__i"); then
  157. __new_name="$(echo "${__i//-/_}")"
  158. if [ "$__new_name" != "$__i" ]; then
  159. depends "$__new_name"
  160. else
  161. err "dependency check: couldn't find '$__i' required command."
  162. exit 1
  163. fi
  164. else
  165. if ! test -z "$__path" ; then
  166. export "$(echo "${__i//- /__}")"="$__path"
  167. fi
  168. fi
  169. done
  170. }
  171. get_os() {
  172. local uname_output
  173. uname_output="$(uname -s)"
  174. case "${uname_output}" in
  175. Linux*) e linux;;
  176. Darwin*) e mac;;
  177. CYGWIN*) e cygwin;;
  178. MINGW*) e mingw;;
  179. *) e "UNKNOWN:${uname_output}";;
  180. esac
  181. }
  182. read-0() {
  183. local eof= IFS=''
  184. while [ "$1" ]; do
  185. read -r -d '' -- "$1" || eof=1
  186. shift
  187. done
  188. [ -z "$eof" ]
  189. }
  190. read-0a() {
  191. local eof= IFS=''
  192. while [ "$1" ]; do
  193. IFS='' read -r -d $'\n' -- "$1" || eof=1
  194. shift
  195. done
  196. [ -z "$eof" ]
  197. }
  198. p0() {
  199. printf "%s\0" "$@"
  200. }
  201. cla.normalize() {
  202. local letters arg i
  203. while [ "$#" != 0 ]; do
  204. arg=$1
  205. case "$arg" in
  206. --)
  207. p0 "$@"
  208. return 0
  209. ;;
  210. --*=*|-*=*)
  211. shift
  212. set -- "${arg%%=*}" "${arg#*=}" "$@"
  213. continue
  214. ;;
  215. --*|-?) :;;
  216. -*)
  217. letters=${arg:1}
  218. shift
  219. i=${#letters}
  220. while ((i--)); do
  221. set -- -${letters:$i:1} "$@"
  222. done
  223. continue
  224. ;;
  225. esac
  226. p0 "$arg"
  227. shift
  228. done
  229. }
  230. docker_has_image() {
  231. local image="$1"
  232. images=$(docker images -q "$image" 2>/dev/null) || {
  233. err "docker images call has failed unexpectedly."
  234. return 1
  235. }
  236. [ -n "$images" ]
  237. }
  238. docker_image_id() {
  239. local image="$1"
  240. image_id=$(docker inspect "$image" --format='{{.Id}}') || return 1
  241. echo "$image_id"
  242. }
  243. ##
  244. ## Compose-core common functions
  245. ##
  246. list_compose_vars() {
  247. while read-0a def; do
  248. def="${def##* }"
  249. def="${def%=*}"
  250. p0 "$def"
  251. done < <(declare -p | grep "^declare -x COMPOSE_[A-Z_]\+=\"")
  252. }
  253. get_running_compose_containers() {
  254. ## XXXvlab: docker bug: there will be a final newline anyway
  255. docker ps --filter label="compose.service" --format='{{.ID}}'
  256. }
  257. get_volumes_for_container() {
  258. local container="$1"
  259. docker inspect \
  260. --format '{{range $mount := .Mounts}}{{$mount.Source}}{{"\x00"}}{{$mount.Destination}}{{"\x00"}}{{end}}' \
  261. "$container"
  262. }
  263. is_volume_used() {
  264. local volume="$1"
  265. while read container_id; do
  266. while read-0 src dst; do
  267. [ "$src" == "$volume" ] && return 0
  268. done < <(get_volumes_for_container "$container_id")
  269. done < <(get_running_compose_containers)
  270. return 1
  271. }
  272. _MULTIOPTION_REGEX='^((-[a-zA-Z]|--[a-zA-Z0-9-]+)(, )?)+'
  273. _MULTIOPTION_REGEX_LINE_FILTER=$_MULTIOPTION_REGEX'(\s|=)'
  274. ##
  275. ## compose launcher functions
  276. ##
  277. clean_unused_sessions() {
  278. for f in "$SESSION_DIR/"*; do
  279. [ -e "$f" ] || continue
  280. is_volume_used "$f" && continue
  281. ## XXXvlab: the second rmdir should not be useful
  282. rm -f "$f" >/dev/null || rmdir "$f" >/dev/null || {
  283. debug "Unexpected session remnants $f"
  284. }
  285. done
  286. }
  287. check_no_links_subdirs() {
  288. local dir
  289. for dir in "$@"; do
  290. [ -d "$dir" ] || continue
  291. if [ -L "$dir" ]; then
  292. err "Unfortunately, this compose launcher do not support yet symlinks in charm-store."
  293. echo " Found symlink in charm-store: $dir" >&2
  294. return 1
  295. fi
  296. [ -e "$dir/metadata.yml" ] && continue
  297. check_no_links_subdirs "$dir"/* || return 1
  298. done
  299. }
  300. ## requires docker_run_opts to be set
  301. get_compose_file_opt() {
  302. local compose_docker_image="$1" hash override
  303. shift
  304. image_id=$(docker_image_id "$compose_docker_image")
  305. override=$(get_volume_opt "${docker_run_opts[@]}") || return 1
  306. if [ -n "$override" ]; then
  307. if ! [ -f "$override" ]; then
  308. err "Invalid override of 'compose-core' detected. File '$override' does not exist on host."
  309. exit 1
  310. fi
  311. hash=$( { p0 "$image_id"; cat "$override"; } | md5_compat)
  312. else
  313. hash=$(p0 "$image_id" | md5_compat)
  314. fi
  315. _get_compose_file_opt "$hash" "$override" "$@" || exit 1
  316. }
  317. _get_compose_file_opt() {
  318. local hash_bin="$1" override="$2" \
  319. cache_file="$COMPOSE_CACHE/$FUNCNAME.cache.$(p0 "$@" | md5_compat)"
  320. if [ -e "$cache_file" ]; then
  321. cat "$cache_file" &&
  322. touch "$cache_file" || return 1
  323. return 0
  324. fi
  325. shift 2
  326. DC_MATCH_MULTI=$(get_compose_multi_opts_list "$hash_bin" "$override") || return 1
  327. DC_MATCH_SINGLE=$(get_compose_single_opts_list "$hash_bin" "$override") || return 1
  328. while read-0 arg; do
  329. case "$arg" in
  330. "-f"|"--file")
  331. read-0 value
  332. e "$value"
  333. return 0
  334. ;;
  335. --*|-*)
  336. if str_pattern_matches "$arg" $DC_MATCH_MULTI; then
  337. read-0 value
  338. opts+=("$arg" "$value")
  339. shift
  340. elif str_pattern_matches "$arg" $DC_MATCH_SINGLE; then
  341. opts+=("$arg")
  342. else
  343. debug "Unknown option '$arg'. Didn't manage to pre-parse correctly options."
  344. return 1
  345. fi
  346. ;;
  347. *)
  348. return 1
  349. ;;
  350. esac
  351. done < <(cla.normalize "$@") | tee "$cache_file"
  352. }
  353. replace_compose_file_opt() {
  354. local compose_docker_image="$1" hash override
  355. shift
  356. image_id=$(docker_image_id "$compose_docker_image")
  357. override=$(get_volume_opt "${docker_run_opts[@]}") || return 1
  358. if [ -n "$override" ]; then
  359. if ! [ -f "$override" ]; then
  360. err "Invalid override of 'compose-core' detected. File '$override' does not exist on host."
  361. exit 1
  362. fi
  363. hash=$( { p0 "$image_id"; cat "$override"; } | md5_compat)
  364. else
  365. hash=$(p0 "$image_id" | md5_compat)
  366. fi
  367. _replace_compose_file_opt "$hash" "$override" "$@" || exit 1
  368. }
  369. _replace_compose_file_opt() {
  370. local hash_bin="$1" override="$2" \
  371. cache_file="$COMPOSE_CACHE/$FUNCNAME.cache.$(p0 "$@" | md5_compat)"
  372. if [ -e "$cache_file" ]; then
  373. cat "$cache_file" &&
  374. touch "$cache_file" || return 1
  375. return 0
  376. fi
  377. debug "Replacing '-f|--file' argument in command line."
  378. shift 2
  379. DC_MATCH_MULTI=$(get_compose_multi_opts_list "$hash_bin" "$override") || return 1
  380. DC_MATCH_SINGLE=$(get_compose_single_opts_list "$hash_bin" "$override") || return 1
  381. args=()
  382. while read-0 arg; do
  383. case "$arg" in
  384. "-f"|"--file")
  385. read-0 value
  386. args+=("$arg" "${value##*/}")
  387. ;;
  388. --*|-*)
  389. if str_pattern_matches "$arg" $DC_MATCH_MULTI; then
  390. read-0 value
  391. args+=("$arg" "$value")
  392. shift
  393. elif str_pattern_matches "$arg" $DC_MATCH_SINGLE; then
  394. args+=("$arg")
  395. else
  396. err "Unknown option '$arg'. Didn't manage to pre-parse correctly options."
  397. return 1
  398. fi
  399. ;;
  400. *)
  401. args+=("$arg")
  402. while read-0 arg; do
  403. args+=("$arg")
  404. done
  405. ;;
  406. esac
  407. done < <(cla.normalize "$@")
  408. p0 "${args[@]}" | tee "$cache_file"
  409. }
  410. get_compose_opts_list() {
  411. local hash_bin="$1" override="$2" \
  412. cache_file="$COMPOSE_CACHE/$FUNCNAME.cache.$1"
  413. if [ -e "$cache_file" ]; then
  414. cat "$cache_file" &&
  415. touch "$cache_file" || return 1
  416. return 0
  417. fi
  418. debug "Pre-Launching docker to retrieve command line argument definitions."
  419. opts_list=()
  420. if [ -n "$override" ]; then
  421. opts_list+=("-v" "$override:/usr/local/bin/compose-core:ro")
  422. fi
  423. compose_opts_help=$(docker run "${opts_list[@]}" "$COMPOSE_DOCKER_IMAGE" --help 2>/dev/null)
  424. echo "$compose_opts_help" |
  425. grep '^Options:' -A 20000 |
  426. tail -n +2 |
  427. { cat ; echo; } |
  428. grep -E -m 1 "^\S*\$" -B 10000 |
  429. head -n -1 |
  430. grep -E "^\s+-" |
  431. sed -r 's/\s+((((-[a-zA-Z]|--[a-zA-Z0-9-]+)( [A-Z=]+|=[^ ]+)?)(, )?)+)\s+.*$/\1/g' |
  432. tee "$cache_file" || return 1
  433. }
  434. multi_opts_filter() {
  435. grep -E "$_MULTIOPTION_REGEX_LINE_FILTER" |
  436. sed -r "s/^($_MULTIOPTION_REGEX)(\s|=).*$/\1/g" |
  437. tr ',' "\n" | nspc
  438. }
  439. single_opts_filter() {
  440. grep -E -v "$_MULTIOPTION_REGEX_LINE_FILTER" |
  441. tr ',' "\n" | nspc
  442. }
  443. get_compose_multi_opts_list() {
  444. local hash_bin="$1" override="$2" \
  445. cache_file="$COMPOSE_CACHE/$FUNCNAME.cache.$1" opts_list
  446. if [ -e "$cache_file" ]; then
  447. cat "$cache_file" &&
  448. touch "$cache_file" || return 1
  449. return 0
  450. fi
  451. opts_list=$(get_compose_opts_list "$hash_bin" "$override") || return 1
  452. echo "$opts_list" | multi_opts_filter | tee "$cache_file"
  453. }
  454. get_compose_single_opts_list() {
  455. local hash_bin="$1" override="$2" \
  456. cache_file="$COMPOSE_CACHE/$FUNCNAME.cache.$1" opts_list
  457. if [ -e "$cache_file" ]; then
  458. cat "$cache_file" &&
  459. touch "$cache_file" || return 1
  460. return 0
  461. fi
  462. opts_list=$(get_compose_opts_list "$hash_bin" "$override") || return 1
  463. echo "$opts_list" | single_opts_filter | tee "$cache_file"
  464. }
  465. get_volume_opt() {
  466. local cache_file="$COMPOSE_CACHE/$FUNCNAME.cache.$(p0 "$@" | md5_compat)"
  467. if [ -e "$cache_file" ]; then
  468. cat "$cache_file" &&
  469. touch "$cache_file" || return 1
  470. return 0
  471. fi
  472. while [ "$#" != 0 ]; do
  473. case "$1" in
  474. "-v")
  475. dst="${2#*:}"
  476. dst="${dst%:*}"
  477. if [ "$dst" == "/usr/local/bin/compose-core" ]; then
  478. override="${2%%:*}"
  479. debug "Override of compose-core found: $override"
  480. fi
  481. shift;;
  482. "-e"|"-w")
  483. shift;;
  484. *)
  485. :
  486. ;;
  487. esac
  488. shift
  489. done
  490. { [ -n "$override" ] && echo "$override"; } | tee "$cache_file"
  491. }
  492. get_tz() {
  493. if [ -n "$TZ" ]; then
  494. :
  495. elif [ -n "$COMPOSE_LOCAL_ROOT" ] && ## previous compose run
  496. [ -e "$COMPOSE_LOCAL_ROOT/etc/timezone" ]; then
  497. read -r TZ < "$COMPOSE_LOCAL_ROOT/etc/timezone"
  498. elif [ -e "/etc/timezone" ]; then ## debian host system timezone
  499. read -r TZ < /etc/timezone
  500. elif [ -e "/etc/localtime" ]; then ## redhat and macosx sys timezone
  501. local fullpath dirname
  502. fullpath="$(readlink -f /etc/localtime)"
  503. dirname="${fullpath%/*}"
  504. TZ=${TZ:-${fullpath##*/}/${dirname##*/}}
  505. else
  506. err "Timezone not found nor inferable !"
  507. echo " compose relies on '/etc/timezone' or '/etc/localtime' to be present " >&2
  508. echo " so as to ensure same timezone for all containers that need it." >&2
  509. echo >&2
  510. echo " You can set a default value for compose by create issuing:" >&2
  511. echo >&2
  512. if [ -n "$COMPOSE_LOCAL_ROOT" ] && [ "$UID" != 0 ]; then
  513. echo " mkdir -p $COMPOSE_LOCAL_ROOT/etc &&" >&2
  514. echo " echo \"Europe/Paris\" > $COMPOSE_LOCAL_ROOT/etc/timezone" >&2
  515. else
  516. echo " echo \"Europe/Paris\" > /etc/timezone" >&2
  517. fi
  518. echo >&2
  519. echo " Of course, you can change 'Europe/Paris' value by any other valid timezone." >&2
  520. echo " timezone." >&2
  521. echo >&2
  522. echo " Notice you can also use \$TZ environment variable, but the value" >&2
  523. echo " will be necessary each time you launch compose." >&2
  524. echo >&2
  525. return 1
  526. fi
  527. e "$TZ"
  528. }
  529. pretty_print() {
  530. while [ "$#" != 0 ]; do
  531. case "$1" in
  532. "-v"|"-e"|"-w")
  533. e "$1" "$2" "\\"$'\n'
  534. shift;;
  535. *)
  536. e "$1 ";;
  537. esac
  538. shift
  539. done
  540. }
  541. mk_docker_run_options() {
  542. ## Order matters, files get to override vars
  543. compose_config_files=(
  544. ## DEFAULT LINUX VARS
  545. /etc/default/charm
  546. /etc/default/datastore
  547. /etc/default/compose
  548. ## COMPOSE SYSTEM-WIDE FILES
  549. /etc/compose.conf
  550. /etc/compose.local.conf
  551. /etc/compose/local.conf
  552. ## COMPOSE USER FILES
  553. ~/.compose/etc/local.conf
  554. ~/.compose.conf
  555. )
  556. docker_run_opts=("-v" "/var/run/docker.sock:/var/run/docker.sock")
  557. ##
  558. ## Load config files
  559. ##
  560. if [ -z "$DISABLE_SYSTEM_CONFIG_FILE" ]; then
  561. ## XXXvlab: should provide YML config opportunities in possible parent dirs ?
  562. ## userdir ? and global /etc/compose.yml ?
  563. for cfgfile in "${compose_config_files[@]}"; do
  564. [ -e "$cfgfile" ] || continue
  565. docker_run_opts+=("-v" "$cfgfile:$cfgfile:ro")
  566. . "$cfgfile"
  567. done
  568. else
  569. docker_run_opts+=("-e" "DISABLE_SYSTEM_CONFIG_FILE=$DISABLE_SYSTEM_CONFIG_FILE")
  570. fi
  571. COMPOSE_LOCAL_ROOT=${COMPOSE_LOCAL_ROOT:-"$HOME/.compose"}
  572. case "$(get_os)" in
  573. linux)
  574. COMPOSE_VAR=${COMPOSE_VAR:-/var/lib/compose}
  575. COMPOSE_CACHE=${COMPOSE_CACHE:-/var/cache/compose}
  576. DATASTORE=${DATASTORE:-/srv/datastore/data}
  577. CONFIGSTORE=${CONFIGSTORE:-/srv/datastore/config}
  578. if [ "$UID" == 0 ]; then
  579. SESSION_DIR=${SESSION_DIR:-"$COMPOSE_VAR"/sessions}
  580. CHARM_STORE=${CHARM_STORE:-/srv/charm-store}
  581. TZ_PATH=${TZ_PATH:-"$COMPOSE_VAR"/timezones}
  582. else
  583. SESSION_DIR=${SESSION_DIR:-"$COMPOSE_LOCAL_ROOT"/sessions}
  584. CHARM_STORE=${CHARM_STORE:-"$HOME"/.charm-store}
  585. TZ_PATH=${TZ_PATH:-"$COMPOSE_LOCAL_ROOT"/timezones}
  586. fi
  587. ;;
  588. mac)
  589. COMPOSE_VAR=${COMPOSE_VAR:-"$COMPOSE_LOCAL_ROOT"/lib}
  590. COMPOSE_CACHE=${COMPOSE_CACHE:-"$COMPOSE_LOCAL_ROOT"/cache}
  591. SESSION_DIR=${SESSION_DIR:-"$COMPOSE_LOCAL_ROOT"/sessions}
  592. DATASTORE=${DATASTORE:-"$COMPOSE_LOCAL_ROOT"/data}
  593. CONFIGSTORE=${CONFIGSTORE:-"$COMPOSE_LOCAL_ROOT"/config}
  594. CHARM_STORE=${CHARM_STORE:-"$HOME"/.charm-store}
  595. TZ_PATH=${TZ_PATH:-"$COMPOSE_LOCAL_ROOT"/timezones}
  596. ;;
  597. *)
  598. echo "System '$os' not supported yet." >&2
  599. exit 1
  600. ;;
  601. esac
  602. mkdir -p "$COMPOSE_CACHE"
  603. ## get TZ value and prepare TZ_PATH
  604. TZ=$(get_tz) || exit 1
  605. mkdir -p "${TZ_PATH}"
  606. TZ_PATH="${TZ_PATH}/$(e "$TZ" | sha256sum | cut -c 1-8)" || exit 1
  607. [ -e "$TZ_PATH" ] || e "$TZ" > "$TZ_PATH"
  608. ## CACHE/DATA DIRS
  609. docker_run_opts+=("-v" "$COMPOSE_VAR:/var/lib/compose")
  610. docker_run_opts+=("-v" "$COMPOSE_CACHE:/var/cache/compose")
  611. docker_run_opts+=("-v" "$TZ_PATH:/etc/timezone:ro")
  612. ##
  613. ## Checking vars
  614. ##
  615. ## CHARM_STORE
  616. [ -e "$CHARM_STORE" ] || mkdir -p "$CHARM_STORE" || exit 1
  617. [ -L "$CHARM_STORE" ] && {
  618. CHARM_STORE=$(readlink -f "$CHARM_STORE") || exit 1
  619. }
  620. docker_run_opts+=(
  621. "-v" "$CHARM_STORE:/srv/charm-store:ro"
  622. "-e" "CHARM_STORE=/srv/charm-store"
  623. "-e" "HOST_CHARM_STORE=$CHARM_STORE"
  624. )
  625. check_no_links_subdirs "$CHARM_STORE"/* || exit 1
  626. ## DEFAULT_COMPOSE_FILE
  627. if [ "${DEFAULT_COMPOSE_FILE+x}" ]; then
  628. DEFAULT_COMPOSE_FILE=$(realpath "$DEFAULT_COMPOSE_FILE")
  629. dirname=$(dirname "$DEFAULT_COMPOSE_FILE")/
  630. if [ -e "${DEFAULT_COMPOSE_FILE}" ]; then
  631. docker_run_opts+=("-v" "$dirname:$dirname:ro")
  632. fi
  633. fi
  634. ## COMPOSE_YML_FILE
  635. if [ "${COMPOSE_YML_FILE+x}" ]; then
  636. if [ -e "${COMPOSE_YML_FILE}" ]; then
  637. docker_run_opts+=(
  638. "-v" "$COMPOSE_YML_FILE:/tmp/compose.yml:ro"
  639. "-e" "COMPOSE_YML_FILE=/tmp/compose.yml"
  640. "-e" "HOST_COMPOSE_YML_FILE=/tmp/compose.yml"
  641. )
  642. fi
  643. fi
  644. ## DATASTORE and CONFIGSTORE
  645. docker_run_opts+=(
  646. "-v" "$DATASTORE:/srv/datastore/data:rw"
  647. "-e" "DATASTORE=/srv/datastore/data"
  648. "-e" "HOST_DATASTORE=$DATASTORE"
  649. "-v" "$CONFIGSTORE:/srv/datastore/config:rw"
  650. "-e" "CONFIGSTORE=/srv/datastore/config"
  651. "-e" "HOST_CONFIGSTORE=$CONFIGSTORE"
  652. )
  653. docker_run_opts+=("-v" "$HOME/.docker:/root/.docker")
  654. COMPOSE_DOCKER_IMAGE=${COMPOSE_DOCKER_IMAGE:-docker.0k.io/compose}
  655. docker_run_opts+=("-e" "COMPOSE_DOCKER_IMAGE=$COMPOSE_DOCKER_IMAGE")
  656. if ! docker_has_image "$COMPOSE_DOCKER_IMAGE"; then
  657. docker pull "$COMPOSE_DOCKER_IMAGE" || exit 1
  658. fi
  659. ## SSH config
  660. docker_run_opts+=(
  661. "-v" "$HOME/.ssh:/root/.ssh:ro"
  662. "-v" "/etc/ssh:/etc/ssh:ro"
  663. )
  664. COMPOSE_LAUNCHER_BIN=$(readlink -f "${BASH_SOURCE[0]}")
  665. docker_run_opts+=("-v" "$COMPOSE_LAUNCHER_BIN:/usr/local/bin/compose")
  666. while read-0 var; do
  667. case "$var" in
  668. COMPOSE_YML_FILE|COMPOSE_LAUNCHER_BIN|COMPOSE_DOCKER_IMAGE|\
  669. COMPOSE_LAUNCHER_OPTS|COMPOSE_VAR|COMPOSE_CACHE)
  670. :
  671. ;;
  672. *)
  673. docker_run_opts+=("-e" "$var=${!var}")
  674. ;;
  675. esac
  676. done < <(list_compose_vars)
  677. compose_file=$(get_compose_file_opt "$COMPOSE_DOCKER_IMAGE" "$@") || exit 1
  678. if [ -z "$compose_file" ]; then
  679. ## Find a compose.yml in parents
  680. debug "No config file specified on command line arguments"
  681. debug "Looking for 'compose.yml' in self and parents.."
  682. if parent=$(while true; do
  683. [ -e "./compose.yml" ] && {
  684. echo "$PWD"
  685. exit 0
  686. }
  687. [ "$PWD" == "/" ] && exit 1
  688. cd ..
  689. done
  690. ); then
  691. compose_file="$(realpath "$parent"/"compose.yml")"
  692. debug " .. found '$compose_file'"
  693. else
  694. debug " .. not found."
  695. fi
  696. fi
  697. if [ -n "$compose_file" ]; then
  698. if ! [ -f "$compose_file" ]; then
  699. die "Specified compose file '$compose_file' not found."
  700. fi
  701. compose_file="$(realpath "$compose_file")"
  702. parent_dir="${compose_file%/*}"
  703. docker_path=/var/lib/compose/root/${parent_dir##*/}/${compose_file##*/}
  704. docker_run_opts+=(
  705. "-e" "COMPOSE_YML_FILE=${compose_file##*/}"
  706. "-v" "${compose_file}:${docker_path}:ro"
  707. "-w" "${docker_path%/*}"
  708. )
  709. else
  710. docker_path=/var/lib/compose/root
  711. docker_run_opts+=(
  712. "-w" "${docker_path}"
  713. )
  714. fi
  715. clean_unused_sessions
  716. filename=$(mktemp -p /tmp/ -t launch_opts-XXXXXXXXXXXXXXXX)
  717. {
  718. p0 "${docker_run_opts[@]}"
  719. } > "$filename"
  720. sha=$(sha256sum "$filename")
  721. sha=${sha:0:64}
  722. src="$SESSION_DIR/$UID-$sha"
  723. dest="/var/lib/compose/sessions/$UID-$sha"
  724. {
  725. p0 "-v" "$SESSION_DIR/$UID-$sha:$dest:ro"
  726. p0 "-e" "COMPOSE_LAUNCHER_OPTS=$dest"
  727. p0 "-e" "COMPOSE_LAUNCHER_BIN=$COMPOSE_LAUNCHER_BIN"
  728. } >> "$filename"
  729. mkdir -p "$SESSION_DIR" || return 1
  730. mv -f "$filename" "$SESSION_DIR/$UID-$sha" || return 1
  731. echo "$SESSION_DIR/$UID-$sha"
  732. if [ -n "$DEBUG" ]; then
  733. echo "${WHITE}Environment:${NORMAL}"
  734. echo " COMPOSE_DOCKER_IMAGE: $COMPOSE_DOCKER_IMAGE"
  735. echo " CHARM_STORE: $CHARM_STORE"
  736. echo " DATASTORE: $DATASTORE"
  737. echo " CONFIGSTORE: $CONFIGSTORE"
  738. echo " COMPOSE_VAR: $COMPOSE_VAR"
  739. echo " COMPOSE_CACHE: $COMPOSE_CACHE"
  740. echo " SESSION_DIR: $SESSION_DIR"
  741. echo " TZ_PATH: $TZ_PATH"
  742. fi >&2
  743. }
  744. run() {
  745. local os docker_run_opts
  746. docker_run_opts=()
  747. if [ -z "$COMPOSE_LAUNCHER_OPTS" ]; then
  748. COMPOSE_LAUNCHER_OPTS="$(mk_docker_run_options "$@")" || return 1
  749. fi
  750. while read-0 opt; do
  751. docker_run_opts+=("$opt")
  752. ## catch COMPOSE_DOCKER_IMAGE
  753. if [[ "$env" == "true" && "$opt" == "COMPOSE_DOCKER_IMAGE="* ]]; then
  754. COMPOSE_DOCKER_IMAGE=${opt##COMPOSE_DOCKER_IMAGE=}
  755. elif [ "$opt" == "-e" ]; then
  756. env=true
  757. else
  758. env=
  759. fi
  760. if [[ "$vol" == "true" && "$opt" == *":/var/cache/compose" ]]; then
  761. COMPOSE_CACHE=${opt%%:*}
  762. elif [ "$opt" == "-v" ]; then
  763. vol=true
  764. else
  765. vol=
  766. fi
  767. done < <(cat "$COMPOSE_LAUNCHER_OPTS")
  768. array_read-0 cmd_args < <(replace_compose_file_opt "$COMPOSE_DOCKER_IMAGE" "$@")
  769. set -- "${cmd_args[@]}"
  770. [ -t 0 ] && docker_run_opts+=("-i")
  771. [ -t 1 ] && docker_run_opts+=("-t")
  772. if [ -n "$DEBUG" ] || [ -n "$DRY_RUN" ]; then
  773. debug "${WHITE}Launching:${NORMAL}"
  774. echo "docker run --rm \\"
  775. pretty_print "${docker_run_opts[@]}" | sed -r 's/^/ /g;s/([^\])$/\1\\\n/g'
  776. if [ -z "$ENTER" ]; then
  777. echo " ${COMPOSE_DOCKER_IMAGE} \\"
  778. echo " " "$@"
  779. else
  780. echo " --entrypoint bash \\"
  781. echo " ${COMPOSE_DOCKER_IMAGE}"
  782. fi
  783. fi | { if [ -n "$DEBUG" ]; then sed -r 's/^/ /g'; else cat; fi } >&2
  784. if [ -z "$DRY_RUN" ]; then
  785. debug "${WHITE}Execution:${NORMAL}"
  786. if [ -z "$ENTER" ]; then
  787. exec docker run --rm "${docker_run_opts[@]}" "${COMPOSE_DOCKER_IMAGE}" "$@"
  788. else
  789. exec docker run --rm "${docker_run_opts[@]}" \
  790. --entrypoint bash \
  791. "${COMPOSE_DOCKER_IMAGE}"
  792. fi
  793. fi
  794. }
  795. [ "$SOURCED" ] && return 0
  796. ##
  797. ## Code
  798. ##
  799. depends docker cat readlink sed realpath tee sed grep tail
  800. ansi_color "${ansi_color:-tty}"
  801. run "$@"